<?php

/*
Plugin Name: myLCO
Plugin URI: http://link-check.org/
Description: Check your Backlinks
Version: 0.3
Author: Dennis Ploetner
Author URI: http://lloc.de/
License: GPL2
*/

/*
Copyright 2010  Dennis Ploetner  (email : re@lloc.de)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!class_exists ('myLCO')) {

    require_once (dirname (__FILE__) . '/include/myLCOresource.php');
    require_once (dirname (__FILE__) . '/include/myLCOtemplate.php');
    require_once (dirname (__FILE__) . '/include/myLCOicon.php');
    require_once (dirname (__FILE__) . '/include/myLCOoptions.php');

    class myLCO {

        var $options;
        var $plugindir;

        function __construct () {
            $this->options = new myLCOoptions ();
            $this->plugindir = PLUGINDIR . '/' . dirname (plugin_basename (__FILE__));
            add_action ('init', array (&$this, 'init'));
            add_action ('admin_menu', array (&$this, 'menu'));
        }

        function init () {
            load_plugin_textdomain ('myLCO', false, dirname (plugin_basename (__FILE__)) . '/lang');
        }

        function menu () {
            add_menu_page (__ ('myLCO', 'myLCO'), __ ('myLCO', 'myLCO'), 'administrator', __FILE__, array (&$this, 'main'));
            add_submenu_page (__FILE__, __('myLCO &raquo; Backlink-Verwaltung', 'myLCO'), __('&Uuml;bersicht', 'myLCO'), 'administrator', __FILE__, array (&$this, 'main'));
            add_submenu_page (__FILE__, __('myLCO &raquo; Bearbeiten', 'myLCO'), __('Bearbeiten', 'myLCO'), 'administrator', 'myLCO_edit', array (&$this, 'edit'));
            add_submenu_page (__FILE__, __('myLCO &raquo; Einstellungen', 'myLCO'), __('Einstellungen', 'myLCO'), 'administrator', 'myLCO_options', array (&$this, 'options'));
        }

        function get_menu ($current = 0) {
            $arr = array (
                plugin_basename (__FILE__) => __ ('&Uuml;bersicht', 'myLCO'),
                'myLCO_edit' => __ ('Bearbeiten', 'myLCO'),
                'myLCO_options' => __ ('Einstellungen', 'myLCO'),
            );
            $i = 0; $retval = '';
            foreach ($arr as $key => $value) {
                $retval .=
                    '<li><a href="/wp-admin/admin.php?page=' . $key . '"' .
                    ($current == $i ? ' class="current"' : '') . '>' . $value .
                    '</a> |</li>';
                $i++;
            }
            return '<ul class="subsubsub">' . $retval . '<li><a href="/wp-admin/link-manager.php">Link Manager</a></li></ul>';
        }

        function get_bookmarks () {
            if (!isset ($this->bookmarks)) {
                $this->bookmarks = array ();
                $bookmarks = get_bookmarks ($this->options->get ());
                foreach ($bookmarks as $bookmark) {
                    $this->bookmarks[$bookmark->link_id] = new myLCObookmark ($bookmark);
                }
            }
            return $this->bookmarks;
        }

        function main () {
            $tpage = new myLCOtemplate (dirname (__FILE__) . '/templates/page.php');
            $tpage->menu = $this->get_menu ();

            $bookmarks = $this->get_bookmarks ();
            if (empty ($bookmarks)) {
                $tpage = $this->incomplete ($tpage);
            } else {
                $tpage->title = __ ('myLCO - Backlink-Verwaltung', 'myLCO');
                $tpage->message = '';

                $tcontent = new myLCOtemplate (dirname (__FILE__) . '/templates/main.php');
                $tcontent->URL = __ ('URL', 'myLCO');
                $tcontent->PR = __ ('PR', 'myLCO');
                $tcontent->Name = __ ('Name', 'myLCO');
                $tcontent->Backlinks = __ ('Backlinks', 'myLCO');

                $temp = '';
                $pr = new myLCOpagerank ();
                $str = '<tr><td><a href="/wp-admin/admin.php?page=myLCO_edit&amp;cl=%s" title="%s">%s</td><td>%s</td><td><a href="%s" title="%s" target="_blank">%s</td><td>%s</td></tr>';
                foreach ($bookmarks as $bookmark) {
                    $temp .= sprintf (
                        $str,
                        $bookmark->link_id,
                        __ ('Backlinks bearbeiten...'),
                        $bookmark->link_url,
                        $pr->getPageRank ($bookmark->link_url),
                        $bookmark->link_url,
                        __ ('Seite besuchen...'),
                        $bookmark->link_name,
                        count ($bookmark->get ())
                    );
                }
                $tcontent->content = $temp;
                $tcontent->Tablenav = sprintf (__ ('Insgesamt %s URLs stehen f&uuml;r die Backlink-Verwaltung zur Verf&uuml;gung.', 'myLCO'), count ($bookmarks));

                $tpage->content = $tcontent->get ();
            }
            echo $tpage->get ();
        }

        function edit () {
            $tpage = new myLCOtemplate (dirname (__FILE__) . '/templates/page.php');
            $tpage->menu = $this->get_menu (1);

            $bookmarks = $this->get_bookmarks ();
            if (empty ($bookmarks)) {
                $tpage = $this->incomplete ($tpage);
            } else {
                $link = (isset ($bookmarks[$_REQUEST['cl']]) ? $bookmarks[$_REQUEST['cl']] : current ($bookmarks));
                $tpage->title = sprintf (__ ('Bearbeiten &quot;%s&quot; (%s)', 'myLCO'), $link->link_name, $link->link_url);

                if (!empty ($_REQUEST['action'])) {
                    if ('delete' == $_REQUEST['action'] && !empty ($_REQUEST['url'])) {
                        $link->delete ($_REQUEST['url']);
                    }
                    if ('check' == $_REQUEST['action'] && !empty ($_REQUEST['url'])) {
                        $link->check ($_REQUEST['url']);
                    }
                }
                if (!empty ($_REQUEST['backlink'])) {
                    $link->add ($_REQUEST['backlink']);
                }
                $tpage->message = '';

                $tform = new myLCOtemplate (dirname (__FILE__) . '/templates/form.php');
                $tform->action = $_SERVER['PHP_SELF'] . '?page=myLCO_edit';
                $tform->change = __ ('Auswahl ändern');
                $tform->insert = __ ('Backlink hinzufügen');

                $temp = '';
                foreach ($bookmarks as $bookmark) {
                    $temp .= $bookmark->option ($_REQUEST['cl']);
                }
                $tform->options = $temp;

                $backlinks = $link->get ();
                if (!empty ($backlinks)) {
                    $tbody = new myLCOtemplate (dirname (__FILE__) . '/templates/edit.php');
                    $tbody->action = $_SERVER['PHP_SELF'] . '?page=myLCO_edit&amp;cl=' . $_REQUEST['cl'];
                    $tbody->URL = __ ('Backlink-URL', 'myLCO');
                    $tbody->PR = __ ('PR', 'myLCO');
                    $tbody->Text = __ ('Linktext', 'myLCO');
                    $tbody->IP = __ ('IP', 'myLCO');
                    $tbody->Status = __ ('Status', 'myLCO');
                    $tbody->Checkdate = __ ('Geprüft am', 'myLCO');
                    $tbody->Check = __ ('Ausgewählte URLs prüfen', 'myLCO');
                    $tbody->Delete = __ ('Ausgewählte URLs löschen', 'myLCO');
                    $tbody->DeleteMessage = __ ('Alle ausgewählten URLs sollen gelöscht werden?\n&quot;Abbrechen&quot; zum Abbrechen, &quot;OK&quot; zum Löschen.', 'myLCO');

                    $temp = '';
                    $ipcounter = array ();
                    $i = 0;
                    $icon = new myLCOicon ($this->plugindir);
                    $pr = new myLCOpagerank ();
                    $trow = new myLCOtemplate (dirname (__FILE__) . '/templates/row.php');
                    foreach ($backlinks as $backlink) {
                        if (isset ($_REQUEST['action']) && $_REQUEST['action'] == 'contact[' . $i . ']') {
                            $backlink->contact_name = $_REQUEST['contact_name'][$i];
                            $backlink->contact_email = $_REQUEST['contact_email'][$i];
                            $backlink->contact_remarks = $_REQUEST['contact_remarks'][$i];
                            $link->modify ($backlink);
                        }
                        $trow->reset ();
                        $trow->alternate_class = ($backlink->is_details () ? ' class="alternate"' : '');
                        $trow->backlink_url = $backlink->getURL ();
                        $trow->backlink_msg = __ ('Seite besuchen...');
                        $trow->backlink_pr = $pr->getPageRank ($backlink->getURL ());
                        $trow->backlink_text = $backlink->link;
                        $trow->backlink_ip = $backlink->getIP ();
                        $trow->backlink_icon = $icon->get ($backlink);
                        $trow->backlink_checkdate = $backlink->getCheckdate ();
                        $trow->hnum = $i;
                        $trow->DetailsLText = __ ('Details', 'myLCO');
                        $trow->CheckLText = __ ('Prüfen', 'myLCO');
                        $trow->DeleteLText = __ ('Löschen', 'myLCO');
                        $trow->contact_name = $backlink->contact_name;
                        $trow->contact_email = $backlink->contact_email;
                        $trow->contact_remarks = $backlink->contact_remarks;
                        $trow->Kname = __ ('Name des Partners', 'myLCO');
                        if ($backlink->contact_email != '') {
                            $trow->Kemail = sprintf (__ ('<a href="mailto:%s">E-Mail</a>', 'myLCO'), $backlink->contact_email);
                        } else {
                            $trow->Kemail = __ ('E-Mail', 'myLCO');
                        }
                        $trow->Kremarks = __ ('Bemerkung / Gegenlink', 'myLCO');
                        $trow->SaveBtn = __ ('Speichern', 'myLCO');
                        $trow->CancelBtn = __ ('Abbrechen', 'myLCO');
                        $trow->ActionLink = $_SERVER['PHP_SELF'] . '?page=myLCO_edit&amp;cl=' . $_REQUEST['cl'];
                        $trow->DeleteMessage = sprintf (__ ('&quot;%s&quot; soll gelöscht werden?\n&quot;Abbrechen&quot; zum Abbrechen, &quot;OK&quot; zum Löschen.', 'myLCO'), $backlink->getURL ());
                        $temp .= $trow->get ();

                        $i++;
                        $ipcounter[$backlink->getIP ()] = 1;
                    }
                    $tbody->content = $temp;
                    $tbody->Tablenav = sprintf (__ ('Insgesamt %s Backlinks (mit %s verschiedenen IP-Adressen) sind bisher angelegt worden.', 'myLCO'), $i, count ($ipcounter));
                }
                $tpage->content = $tform->get () . (isset ($tbody) ? $tbody->get () : '');
            }
            echo $tpage->get ();
        }

        function options () {
            $tpage = new myLCOtemplate (dirname (__FILE__) . '/templates/page.php');
            $tpage->title = __ ('Einstellungen', 'myLCO');
            $tpage->menu = $this->get_menu (2);
            
            if (isset ($_REQUEST['save'])) {
                if (!empty ($_REQUEST['category_name'])) {
                    $this->options->category_name = $_REQUEST['category_name'];
                    $this->options->hide_invisible = (isset ($_REQUEST['hide_invisible']) ? 1 : 0);
                    $this->options->update ();
                    $tpage->message = '<div id="message" class="updated fade"><p>' . __ ('Die Einstellungen wurden gespeichert.') . '</p></div>';
                } else {
                    $tpage->message = '<div id="message"><p>' . __ ('Es wird der Name einer Link-Kategorie benötigt!') . '</p></div>';
                }
            } else {
                $tpage->message = '';
            }

            $tcontent = new myLCOtemplate (dirname (__FILE__) . '/templates/options.php');
            $tcontent->action = $_SERVER['PHP_SELF'] . '?page=myLCO_options';
            $tcontent->option_category = __ ('Verwendete Linkkategorie', 'myLCO');
            $tcontent->category_name = $this->options->category_name;
            $tcontent->option_hide = __ ('Private Links verstecken', 'myLCO');
            $tcontent->hide_invisible = (!empty ($this->options->hide_invisible) ? ' checked="checked"' : '');
            $tcontent->save = __ ('Speichern', 'myLCO');

            $tpage->content = $tcontent->get ();
            echo $tpage->get ();
        }

        function incomplete ($template) {
            $template->title = __ ('Weitere Aktionen sind notwendig', 'myLCO');
            $template->message = '';
            $str = '';
            if (!empty ($this->options->hide_invisible)) {
                $str = __ (' bzw. sollen diese durch die gemachte Angabe in den Einstellungen nicht angezeigt werden');
            }
            $template->content = 
                '<div class="alignleft"><p>' .
                __ (sprintf ('In der Kategorie <strong>%s</strong> befinden sich noch keine Links%s. Benutze für die Zuordnung von Links zur gwünschten Kategorie bitte den <a href="/wp-admin/link-manager.php">Link-Manager</a> von Wordpress oder versuche es mit anderen <a href="%s?page=myLCO_options">Einstellungen</a> des Plugins!', $this->options->category_name, $str, $_SERVER['PHP_SELF']), 'myLCO') .
                '</p></div>';
            return $template;
        }

    }

}

if (function_exists ('register_activation_hook'))
    register_activation_hook (__FILE__, 'myLCO_install');

function myLCO_install() {
    $myLCO = new myLCO ();
    $myLCO->options->update ();
}

if (function_exists ('register_uninstall_hook'))
    register_uninstall_hook (__FILE__, 'myLCO_uninstall');

function myLCO_uninstall() {
    global $wpdb;
    $wpdb->query ("DELETE FROM " . $wpdb->options . " WHERE option_name like '_myLCO%'");
}

if (class_exists ('myLCO') && is_admin ()) {
    $myLCO = new myLCO ();
}

?>
